<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (version 1.7.0_80) on Wed Sep 20 14:52:12 UTC 2017 -->
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<title>BuildController (Gradle API 4.2)</title>
<meta name="date" content="2017-09-20">
<link rel="stylesheet" type="text/css" href="../../../javadoc.css" title="Style">
</head>
<body>
<script type="text/javascript"><!--
    if (location.href.indexOf('is-external=true') == -1) {
        parent.document.title="BuildController (Gradle API 4.2)";
    }
//-->
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar_top">
<!--   -->
</a><a href="#skip-navbar_top" title="Skip navigation links"></a><a name="navbar_top_firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../index-all.html">Index</a></li>
<li><a href="../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../org/gradle/tooling/BuildCancelledException.html" title="class in org.gradle.tooling"><span class="strong">Prev Class</span></a></li>
<li><a href="../../../org/gradle/tooling/BuildException.html" title="class in org.gradle.tooling"><span class="strong">Next Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../index.html?org/gradle/tooling/BuildController.html" target="_top">Frames</a></li>
<li><a href="BuildController.html" target="_top">No Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../../allclasses-noframe.html">All Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_detail">Method</a></li>
</ul>
</div>
<a name="skip-navbar_top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">org.gradle.tooling</div>
<h2 title="Interface BuildController" class="title">Interface BuildController</h2>
</div>
<div class="contentContainer">
<div class="description">
<ul class="blockList">
<li class="blockList">
<hr>
<br>
<pre><a href="../../../org/gradle/api/Incubating.html" title="annotation in org.gradle.api">@Incubating</a>
public interface <span class="strong">BuildController</span></pre>
<div class="block">Provides a <a href="../../../org/gradle/tooling/BuildAction.html" title="interface in org.gradle.tooling"><code>BuildAction</code></a> various ways to control a Gradle build and access information about the build.</div>
<dl><dt><span class="strong">Since:</span></dt>
  <dd>1.8</dd></dl>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method_summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="overviewSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span>Methods</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>&lt;T&gt;&nbsp;T</code></td>
<td class="colLast"><code><strong><a href="../../../org/gradle/tooling/BuildController.html#findModel(java.lang.Class)">findModel</a></strong>(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Class.html?is-external=true" title="class or interface in java.lang">Class</a>&lt;T&gt;&nbsp;modelType)</code>
<div class="block">Fetches a snapshot of the model of the given type, if available.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>&lt;T&gt;&nbsp;T</code></td>
<td class="colLast"><code><strong><a href="../../../org/gradle/tooling/BuildController.html#findModel(org.gradle.tooling.model.Model,%20java.lang.Class)">findModel</a></strong>(<a href="../../../org/gradle/tooling/model/Model.html" title="interface in org.gradle.tooling.model">Model</a>&nbsp;target,
         <a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Class.html?is-external=true" title="class or interface in java.lang">Class</a>&lt;T&gt;&nbsp;modelType)</code>
<div class="block">Fetches a snapshot of the model of the given type, if available.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code><a href="../../../org/gradle/tooling/model/gradle/GradleBuild.html" title="interface in org.gradle.tooling.model.gradle">GradleBuild</a></code></td>
<td class="colLast"><code><strong><a href="../../../org/gradle/tooling/BuildController.html#getBuildModel()">getBuildModel</a></strong>()</code>
<div class="block">Returns an overview of the Gradle build, including some basic details of the projects that make up the build.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>&lt;T&gt;&nbsp;T</code></td>
<td class="colLast"><code><strong><a href="../../../org/gradle/tooling/BuildController.html#getModel(java.lang.Class)">getModel</a></strong>(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Class.html?is-external=true" title="class or interface in java.lang">Class</a>&lt;T&gt;&nbsp;modelType)</code>
<div class="block">Fetches a snapshot of the model of the given type for the default project.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>&lt;T&gt;&nbsp;T</code></td>
<td class="colLast"><code><strong><a href="../../../org/gradle/tooling/BuildController.html#getModel(org.gradle.tooling.model.Model,%20java.lang.Class)">getModel</a></strong>(<a href="../../../org/gradle/tooling/model/Model.html" title="interface in org.gradle.tooling.model">Model</a>&nbsp;target,
        <a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Class.html?is-external=true" title="class or interface in java.lang">Class</a>&lt;T&gt;&nbsp;modelType)</code>
<div class="block">Fetches a snapshot of the model of the given type for the given element, usually a Gradle project.</div>
</td>
</tr>
</table>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method_detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="getModel(java.lang.Class)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getModel</h4>
<pre>&lt;T&gt;&nbsp;T&nbsp;getModel(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Class.html?is-external=true" title="class or interface in java.lang">Class</a>&lt;T&gt;&nbsp;modelType)
           throws <a href="../../../org/gradle/tooling/UnknownModelException.html" title="class in org.gradle.tooling">UnknownModelException</a></pre>
<div class="block">Fetches a snapshot of the model of the given type for the default project. The default project is generally the
 project referenced when a <a href="../../../org/gradle/tooling/ProjectConnection.html" title="interface in org.gradle.tooling"><code>ProjectConnection</code></a> is created.

 <p>Any of following models types may be available, depending on the version of Gradle being used by the target
 build:

 <ul>
     <li><a href="../../../org/gradle/tooling/model/gradle/GradleBuild.html" title="interface in org.gradle.tooling.model.gradle"><code>GradleBuild</code></a></li>
     <li><a href="../../../org/gradle/tooling/model/build/BuildEnvironment.html" title="interface in org.gradle.tooling.model.build"><code>BuildEnvironment</code></a></li>
     <li><a href="../../../org/gradle/tooling/model/GradleProject.html" title="interface in org.gradle.tooling.model"><code>GradleProject</code></a></li>
     <li><a href="../../../org/gradle/tooling/model/gradle/BuildInvocations.html" title="interface in org.gradle.tooling.model.gradle"><code>BuildInvocations</code></a></li>
     <li><a href="../../../org/gradle/tooling/model/gradle/ProjectPublications.html" title="interface in org.gradle.tooling.model.gradle"><code>ProjectPublications</code></a></li>
     <li><a href="../../../org/gradle/tooling/model/idea/IdeaProject.html" title="interface in org.gradle.tooling.model.idea"><code>IdeaProject</code></a></li>
     <li><a href="../../../org/gradle/tooling/model/idea/BasicIdeaProject.html" title="interface in org.gradle.tooling.model.idea"><code>BasicIdeaProject</code></a></li>
     <li><a href="../../../org/gradle/tooling/model/eclipse/EclipseProject.html" title="interface in org.gradle.tooling.model.eclipse"><code>EclipseProject</code></a></li>
     <li><a href="../../../org/gradle/tooling/model/eclipse/HierarchicalEclipseProject.html" title="interface in org.gradle.tooling.model.eclipse"><code>HierarchicalEclipseProject</code></a></li>
 </ul>

 <p>A build may also expose additional custom tooling models. You can use this method to query these models.</div>
<dl><dt><span class="strong">Type Parameters:</span></dt><dd><code>T</code> - The model type.</dd><dt><span class="strong">Parameters:</span></dt><dd><code>modelType</code> - The model type.</dd>
<dt><span class="strong">Returns:</span></dt><dd>The model.</dd>
<dt><span class="strong">Throws:</span></dt>
<dd><code><a href="../../../org/gradle/tooling/UnknownModelException.html" title="class in org.gradle.tooling">UnknownModelException</a></code> - When the default project does not support the requested model.</dd><dt><span class="strong">Since:</span></dt>
  <dd>1.8</dd></dl>
</li>
</ul>
<a name="findModel(java.lang.Class)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>findModel</h4>
<pre><a href="https://docs.oracle.com/javase/7/docs/api/javax/annotation/Nullable.html?is-external=true" title="class or interface in javax.annotation">@Nullable</a>
&lt;T&gt;&nbsp;T&nbsp;findModel(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Class.html?is-external=true" title="class or interface in java.lang">Class</a>&lt;T&gt;&nbsp;modelType)</pre>
<div class="block">Fetches a snapshot of the model of the given type, if available.

 <p>See <a href="../../../org/gradle/tooling/BuildController.html#getModel(java.lang.Class)"><code>getModel(Class)</code></a> for more details.</p></div>
<dl><dt><span class="strong">Type Parameters:</span></dt><dd><code>T</code> - The model type.</dd><dt><span class="strong">Parameters:</span></dt><dd><code>modelType</code> - The model type.</dd>
<dt><span class="strong">Returns:</span></dt><dd>The model, or null if not present.</dd></dl>
</li>
</ul>
<a name="getBuildModel()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getBuildModel</h4>
<pre><a href="../../../org/gradle/tooling/model/gradle/GradleBuild.html" title="interface in org.gradle.tooling.model.gradle">GradleBuild</a>&nbsp;getBuildModel()</pre>
<div class="block">Returns an overview of the Gradle build, including some basic details of the projects that make up the build.
 This is equivalent to calling <code>#getModel(GradleBuild.class)</code>.</div>
<dl><dt><span class="strong">Returns:</span></dt><dd>The model.</dd></dl>
</li>
</ul>
<a name="getModel(org.gradle.tooling.model.Model, java.lang.Class)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getModel</h4>
<pre>&lt;T&gt;&nbsp;T&nbsp;getModel(<a href="../../../org/gradle/tooling/model/Model.html" title="interface in org.gradle.tooling.model">Model</a>&nbsp;target,
             <a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Class.html?is-external=true" title="class or interface in java.lang">Class</a>&lt;T&gt;&nbsp;modelType)
           throws <a href="../../../org/gradle/tooling/UnknownModelException.html" title="class in org.gradle.tooling">UnknownModelException</a></pre>
<div class="block">Fetches a snapshot of the model of the given type for the given element, usually a Gradle project.

 <p>The following elements are supported:

 <ul>
     <li>Any <a href="../../../org/gradle/tooling/model/gradle/BasicGradleProject.html" title="interface in org.gradle.tooling.model.gradle"><code>BasicGradleProject</code></a></li>
     <li>Any <a href="../../../org/gradle/tooling/model/GradleProject.html" title="interface in org.gradle.tooling.model"><code>GradleProject</code></a></li>
     <li>Any <a href="../../../org/gradle/tooling/model/eclipse/EclipseProject.html" title="interface in org.gradle.tooling.model.eclipse"><code>EclipseProject</code></a></li>
     <li>Any <a href="../../../org/gradle/tooling/model/idea/IdeaModule.html" title="interface in org.gradle.tooling.model.idea"><code>IdeaModule</code></a></li>
 </ul>

 <p>See <a href="../../../org/gradle/tooling/BuildController.html#getModel(java.lang.Class)"><code>getModel(Class)</code></a> for more details.</div>
<dl><dt><span class="strong">Type Parameters:</span></dt><dd><code>T</code> - The model type.</dd><dt><span class="strong">Parameters:</span></dt><dd><code>target</code> - The target element, usually a project.</dd><dd><code>modelType</code> - The model type.</dd>
<dt><span class="strong">Returns:</span></dt><dd>The model.</dd>
<dt><span class="strong">Throws:</span></dt>
<dd><code><a href="../../../org/gradle/tooling/UnknownModelException.html" title="class in org.gradle.tooling">UnknownModelException</a></code> - When the target project does not support the requested model.</dd></dl>
</li>
</ul>
<a name="findModel(org.gradle.tooling.model.Model, java.lang.Class)">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>findModel</h4>
<pre><a href="https://docs.oracle.com/javase/7/docs/api/javax/annotation/Nullable.html?is-external=true" title="class or interface in javax.annotation">@Nullable</a>
&lt;T&gt;&nbsp;T&nbsp;findModel(<a href="../../../org/gradle/tooling/model/Model.html" title="interface in org.gradle.tooling.model">Model</a>&nbsp;target,
                       <a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Class.html?is-external=true" title="class or interface in java.lang">Class</a>&lt;T&gt;&nbsp;modelType)</pre>
<div class="block">Fetches a snapshot of the model of the given type, if available.

 <p>See <a href="../../../org/gradle/tooling/BuildController.html#getModel(org.gradle.tooling.model.Model,%20java.lang.Class)"><code>getModel(Model, Class)</code></a> for more details.</p></div>
<dl><dt><span class="strong">Type Parameters:</span></dt><dd><code>T</code> - The model type.</dd><dt><span class="strong">Parameters:</span></dt><dd><code>modelType</code> - The model type.</dd>
<dt><span class="strong">Returns:</span></dt><dd>The model, or null if not present.</dd></dl>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar_bottom">
<!--   -->
</a><a href="#skip-navbar_bottom" title="Skip navigation links"></a><a name="navbar_bottom_firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../index-all.html">Index</a></li>
<li><a href="../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../org/gradle/tooling/BuildCancelledException.html" title="class in org.gradle.tooling"><span class="strong">Prev Class</span></a></li>
<li><a href="../../../org/gradle/tooling/BuildException.html" title="class in org.gradle.tooling"><span class="strong">Next Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../index.html?org/gradle/tooling/BuildController.html" target="_top">Frames</a></li>
<li><a href="BuildController.html" target="_top">No Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../../allclasses-noframe.html">All Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_detail">Method</a></li>
</ul>
</div>
<a name="skip-navbar_bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</body>
</html>
